/*
  Arduino Mega Server for ESP32 SPIFFS
  version 0.17
  2017, Hi-Lab.ru
  
  License: Free for personal use and education, without any warranties
  Home:    http://hi-lab.ru/arduino-mega-server (Russian)
           http://hi-lab.ru/english/arduino-mega-server (English)
  E-mail:  info@hi-lab.ru

  AMS Pro: http://hi-lab.ru/arduino-mega-server/ams-pro (projects and commercial use)
  
  IDE:      Arduino 1.6.5 r2
  Hardware: ESP32 with SPIFFS

  Connections:
  ------------
  SD Card | ESP32
    D3       SS
    CMD      MOSI
    VSS      GND
    VDD      3.3V
    CLK      SCK
    VSS      GND
    D0       MISO

  Optional:
  ---------
  LED (yellow) - D4
  LED (red)    - D21
  LED (green)  - D22
  RGB LED      - D32, D27, D33

  Pathes of the Project:
  ---------------------
  Arduino IDE settings:
  ...\Documents\Arduino

  Libraries folder:
  ...\Documents\Arduino\libraries\

  Sketches folders:
  ...\Sketches\esp32sd\Arduino\arduino_mega_server_esp32sd\
  ...\Sketches\esp32sd\arduino_serial_commander\
  
  Settings:
  ---------
  In Sketch (Wi-Fi): SSID, PASSWORD of your Wi-Fi network
  In Browser:        IP address 192.168.1.70

  Quick start:
  ------------
  0. Connect ESP32 module and microSD card
  1. Install Arduino IDE 1.6.5 (r2)
  2. Install ESP32 drivers (https://github.com/espressif/arduino-esp32)
  3. Put files from folder "sd" to microSD card
  4. Print SSID and PASSWORD of your Wi-Fi router in tab "Wi-Fi" of sketch
  5. Upload Sketch "arduino_mega_server_esp32sd" to module ESP32
  6. Open in your browser address "192.168.1.70"
  7. Enjoy and donate on page http://hi-lab.ru/arduino-mega-server/details/donate
*/

bool releSt = 0; // вот на это может ругаться, что переменная не объявлена
String spisok = ""; // 
// modules
#define FEATURE_UPLOAD
//#define FEATURE_SD
//#define FEATURE_SPIFFS
#define FEATURE_TIME
#define FEATURE_NTP
//#define FEATURE_SEND
//#define FEATURE_MAJOR
//#define FEATURE_CONTACTS
//#define FEATURE_PIRS
#define FEATURE_KEYS
//#define FEATURE_LEDS

//#define FEATURE_ELECTRO

//#define FEATURE_DHT
//#define FEATURE_SD_MESSAGE
//#define ROBOTDYN_FEATURE
//#define FEATURE_TLOG
//#define FEATURE_NRF24
//#define FEATURE_TEMP
//#define FEATURE_WUNDERGR
//#define FEATURE_BME

#define HTTP_FEATURE

#define FEATURE_MYSEN

// debug

#define MYSENS_DEBUG
//#define ELECTRO_DEBUG
//#define EVENTS_CONTACTS
//#define EVENTS_PIRS
//#define TEMP_DEBUG
#define SERIAL_PRINT

#include <pgmspace.h>

//#include "SPI.h"
#include "FS.h"
#include "SPIFFS.h"

#include <WiFi.h>
#include <TimeLib.h>

//#include <Wire.h> 
//#include <LiquidCrystal_I2C.h>

//LiquidCrystal_I2C lcd(0x27,20,4);//set the LCD address to 0x27 for a 16 chars and 2 line display





#define SELF_NAME F("ESP32 SPIFFS")
byte SELF_IP[] = {192, 168, 2, 74};

//byte SELF_IP[] = {192, 168, 2, 78};

// Authorization
#define AUTH_OFF 0
#define AUTH_ON  1
byte authMode = AUTH_OFF;
// online encode: base64encode.org
String AUTH_HASH = "Authorization: Basic YWRtaW46YW1z"; // admin:ams

// time provider
#define TIME_NONE     0
#define TIME_NETWORK  1
#define TIME_RTC      2
byte timeProvider = TIME_NETWORK;

//byte timeProvider = TIME_RTC;

// mode work
#define MODE_SERVER   1
#define MODE_UPDATE   2
byte modeWork = MODE_SERVER;

// duration
time_t prevEventElectroCycle;
time_t prevEventEspLive;
time_t prevEventRequest;



//=============================================
//Alarm text
String AlarmLog = "";

//Log text
String DataLog = "";


// Переменная для текста сообщения
String MessText = "";




// Переменная для типа сообщения
String Info =  "информационное";
String Alarm = "аварийное"; 


// esp partner
#define DUE_OFF 0
#define DUE_ON  1
byte due = DUE_OFF;

// время апдейта

  unsigned long lpTempOldUpdate  = 0;
  unsigned long lpTempUpdate  = 0;

  unsigned long lpContOldUpdate  = 0;
  unsigned long lpContUpdate  = 0; 

  unsigned long lpTemp1OldUpdate  = 0;
  unsigned long lpTemp1Update  = 0; 

  unsigned long lpTemp2OldUpdate  = 0;
  unsigned long lpTemp2Update  = 0;     
//

// modules
#define DISABLE       0
#define ENABLE        1
#define NOT_COMPILLED 2
byte moduleUpload   = NOT_COMPILLED;
byte moduleTime     = NOT_COMPILLED;
byte moduleNtp      = NOT_COMPILLED;
byte moduleEthernet = NOT_COMPILLED;
byte moduleSd       = NOT_COMPILLED;
byte moduleServer   = NOT_COMPILLED;
byte moduleSend     = NOT_COMPILLED;
byte moduleMajor    = NOT_COMPILLED;
byte modulePing     = NOT_COMPILLED;
byte modulePirs     = NOT_COMPILLED;
byte moduleContacts = NOT_COMPILLED;
byte moduleTemp     = NOT_COMPILLED;
byte moduleLeds     = NOT_COMPILLED; 
byte moduleKeys     = NOT_COMPILLED;
byte moduleElectro  = NOT_COMPILLED;
byte moduleNoo      = NOT_COMPILLED;
byte moduleMr1132   = NOT_COMPILLED;
byte moduleNrf24    = NOT_COMPILLED;

byte moduleRobotdyn = NOT_COMPILLED;

byte moduleDHT      = NOT_COMPILLED;

byte moduleTlog     = NOT_COMPILLED;

byte moduleTwundergr = NOT_COMPILLED;

byte moduleBME       = NOT_COMPILLED;

byte moduleMYSEN     = NOT_COMPILLED;//======================

byte moduleHTTP      = NOT_COMPILLED;//=====================



// timers
boolean cycle1s  = false;
boolean cycle5s  = false;
boolean cycle10s = false;
boolean cycle20s = false;
boolean cycle30s = false;
boolean cycle1m  = false;
boolean cycle3m  = false;
boolean cycle5m  = false;
boolean cycle15m = false; // добавил таймера
boolean cycle30m = false;
boolean cycle1h  = false;
boolean cycle1d  = false;
boolean cycle7d  = false;
boolean cycle30d = false; // добавил таймера

// strings
char buf[200];
//String output;



// electro
boolean buttonElectro = 0;

// oscill
boolean oscill = false;

// cyclos
unsigned long cyclos = 0;

#ifdef FEATURE_LEDS
  #define LED_EMPTY 0
  #define LED_PIR 1
  byte modeLed = LED_EMPTY;
#endif

unsigned long check_wifi = 30000;// Проверка соединения каждые 30 секунд

//LiquidCrystal_I2C lcd(0x27,20,4);//set the LCD address to 0x27 for a 16 chars and 2 line display



void install() {

}

void setup() {


//  initMys();
  
  initSerial();
 // initTemp();
  printWelcome();
  initSpiffs();
  initRandom();
  install();
  initEeprom();
  initAbstract();
  initHardware();
  initTimers();
  initWifi();
  //initSd();
  //initHttp(); /////////////////////////////===================
  initNtp();
  initTime();


  initServer();

  //initTemp();//==================

  #ifdef FEATURE_UPLOAD
    initUpload();
  #endif
  #ifdef FEATURE_SEND
    initSend();
  #endif
  #ifdef FEATURE_MAJOR
    initMajordomo();

    majordomoEspLive();
  #endif
  #ifdef FEATURE_TEMP
    initTemp();
  #endif
  #ifdef FEATURE_CONTACTS
    initContacts();
  #endif
  #ifdef FEATURE_PIRS
    initPirs();
  #endif
  #ifdef FEATURE_LEDS
    initLeds();
  #endif
  #ifdef FEATURE_KEYS
    initKeys();
  #endif

  #ifdef ROBOTDYN_FEATURE
    initRobotdyn();
  #endif

  #ifdef FEATURE_DHT
    initDHT();
  #endif

  //==================
  #ifdef FEATURE_MYSEN
    initMYSEN();
  #endif
  //=====================

    #ifdef FEATURE_BME
    Initbme();
  #endif


  #ifdef FEATURE_NRF24
    InitNrf24();
  #endif
  
  #ifdef FEATURE_ELECTRO
    initElectro();
  #endif
  

 #ifdef FEATURE_TLOG
    initTlog();
  #endif

  #ifdef FEATURE_WUNDERGR
    initTwundergr();
  #endif

  #ifdef HTTP_FEATURE
    initHttp();
  #endif
 
  printInitDone();
/*
  lcd.begin();// initialize the lcd with SDA and SCL pins
  
  // Print a message to the LCD.
  
  lcd.backlight();
 // lcd.clear();

  // Print a message to the LCD.
  
  lcd.setCursor(0,0);
  lcd.print("AMS_ESP32 V_0.17");

  lcd.setCursor(0,1);
  lcd.print("TIME");

  lcd.setCursor(8,1);
  lcd.print(":");

  lcd.setCursor(14,1);
  lcd.print(":");

  lcd.setCursor(17,1);
  lcd.print(":");  

  lcd.setCursor(0,2);
  lcd.print("Self_Temp");

  lcd.setCursor(0,3);
  lcd.print("UP_Time");
 */
 // xTaskCreate( lcdTask,      "Lcd",    5000, NULL, 1, NULL );//==============
  xTaskCreate( reconnectTask, "Reconnect", 5000, NULL, 1, NULL );
  
  testInit();
  
} // setup

void loop() {

  // workMys();
  
  #ifdef FEATURE_UPLOAD
    workUpload();
  #endif

  if (modeWork == MODE_SERVER) {
    workTimers();
    workTime();
    workServer();
  
    #ifdef FEATURE_TEMP
      workTemp();
    #endif
    #ifdef FEATURE_CONTACTS
      workContacts();
    #endif
    #ifdef FEATURE_PIRS
      workPirs();
    #endif
    #ifdef FEATURE_KEYS
      workKeys();
    #endif

    #ifdef FEATURE_DHT
      workDHT();
    #endif

   //====================

  #ifdef FEATURE_MYSEN
  
    workMYSEN();
    
    if (cycle5s) {
        lpTempUpdate = (millis() - lpTempOldUpdate) / 1000;
        lpContUpdate = (millis() - lpContOldUpdate) / 1000;

        lpTemp1Update = (millis() - lpTemp1OldUpdate) / 1000;
        lpTemp2Update = (millis() - lpTemp2OldUpdate) / 1000;
      // msTempUpdate = (millis() - msTempOldUpdate) / 1000;

      // parseMsTemp();
   }
  #endif
  //===================    

    #ifdef FEATURE_MAJOR
      majordomoEspLive();
    #endif


    #ifdef FEATURE_NRF24
     
         WorksNrf24();

      if (timer1(1000, 9000)) {
        carousel();
      }
    #endif
    
     #ifdef FEATURE_ELECTRO

     /*
     if (cycle20s) {
      workElectro();
     }
     */

       if (moduleElectro == 1) {
        if (cycle20s) {
          workElectro();
          freqWorks();
        }
        // network oscilloscope
        if (cycle1s && oscill) {
          freqWorks();
        }
      }
    #endif

        #ifdef FEATURE_BME

    if (cycle20s) {
      bmeWorks();
    }
    #endif

 

  #ifdef ROBOTDYN_FEATURE
    workRobotdyn();
  #endif

   #ifdef FEATURE_TLOG
    workTlog();
  #endif

  #ifdef FEATURE_WUNDERGR
   workTwundergr();
  #endif

    #ifdef HTTP_FEATURE
     httpWork();
    #endif

    workAbstract();
    workLoopEnd();

   // if (cycle5m) {
      testRele();
   // }

        //==========================

 //if (cycle5s) {
/*
        lcd.setCursor(6, 1);//
        lcd.print(day());//

        lcd.setCursor(10, 1);//
        lcd.print(month());// 

        lcd.setCursor(12, 1);//
        lcd.print(hour());// 

        lcd.setCursor(15, 1);//
        lcd.print(minute());//

        lcd.setCursor(18, 1);// 
        lcd.print(second());//




        lcd.setCursor(10, 3);
        lcd.print(uptimeString());

 //}




*/
        
  } // MODE_SERVER



/*
  if (WiFi.status() != WL_CONNECTED) {
    WiFi.reconnect(); //или как там оно...точно не помню...в примерах было...
  } 
*/
} // loop
/*
void lcdTask( void * parameter )
{
  while(1)
  {
    workTemp();
    vTaskDelay( 1000 / portTICK_PERIOD_MS ); 
  }
  vTaskDelete( NULL );
}
*/

 // if wifi is down, try reconnecting every 30 seconds
 
void reconnectTask( void * parameter )
{
  while(1)
  {
    Serial.print(F("Check reconnect..."));
    if (WiFi.status() != WL_CONNECTED && (millis() > check_wifi) ) 
    {
      WiFi.reconnect();//
      Serial.println(F("reconnect to WiFi..."));
        WiFi.disconnect();
//      WiFi.begin(ssid, pass);//
    check_wifi = millis() + 30000;
    }
    else
    {
      Serial.println(F("no requirement"));
    }
    vTaskDelay( 20000 / portTICK_PERIOD_MS ); 
  }
  vTaskDelete(NULL);
}
/*
unsigned long check_wifi = 30000;

void loop() {
  // if wifi is down, try reconnecting every 30 seconds
  if ((WiFi.status() != WL_CONNECTED) && (millis() > check_wifi)) {
    Serial.println("Reconnecting to WiFi...");
    WiFi.disconnect();
    WiFi.begin(SSID, PASS);
    check_wifi = millis() + 30000;
  }
}
*/

//===========================================

