#include "DS2423.h" 

extern "C" { 
 // #include "WConstants.h"

   //#include <WConstants.h>
} 

ds2423::ds2423(OneWire* _oneWire, uint8_t* deviceAddress) 
{ 
  _wire = _oneWire; 
  _deviceAddress = deviceAddress; 
} 
//void ds2423::setAddress(uint8_t* deviceAddress) 
//{ 
  //_deviceAddress = deviceAddress; 
//} 

bool ds2423::writeMem(uint8_t* _memPage, int _pageSize, uint8_t _TA1, uint8_t _TA2) 
{ 
  uint8_t myES; //store ES for auth 
   
  _wire->reset(); 
  _wire->select(_deviceAddress); 
  _wire->write(WRITESCRATCHPAD,0); 
  _wire->write(_TA1, 0); //begin address 
  _wire->write(_TA2, 0); //begin address 
  //write _memPage to scratchpad   
  for (int i = 0; i < _pageSize; i++) { 
    _wire->write(_memPage[i], 0); 
  } 
   
  //read and check data in scratchpad 
  _wire->reset(); 
  _wire->select(_deviceAddress); 
  _wire->write(READSCRATCHPAD,0); 
  if (_wire->read() != _TA1) { //check TA1, return if bad 
    return 0; 
  } 
  if (_wire->read() != _TA2) { //check TA2, return if bad 
    return 0; 
  } 
  myES = _wire->read(); // ES Register 
  //check data written 
  for (int i = 0; i < _pageSize; i++) { 
    if (_wire->read() != _memPage[i]) { //return if bad 
      return 0; 
    } 
  } 

  //issue copy with auth data 
  _wire->reset(); 
  _wire->select(_deviceAddress); 
  _wire->write(COPYSCRATCHPAD, 0); 
  _wire->write(_TA1, 0); 
  _wire->write(_TA2, 0); 
  _wire->write(myES, 1); //pull-up! 
//  delay(10); //5ms min strong pullup delay 
   
  _wire->reset(); //just in case... 
  return 1; 
} 


void ds2423::readMem(uint8_t* _memAll, uint8_t _TA1, uint8_t _TA2) 
{ 
  uint8_t tmpReader; 
  bool readFF = 0; 
   
  _wire->reset(); 
  _wire->select(_deviceAddress); 
  _wire->write(READMEMORY, 0); 
  _wire->write(_TA1, 0); 
  _wire->write(_TA2, 0); 
  for (int memPtr = 0; memPtr < 512; memPtr++) { 
    tmpReader = _wire->read(); 
    if (tmpReader == 0xff & !readFF) 
      readFF = 1; 
    else if (tmpReader == 0xff & readFF) 
      // 0xff read twice, hopefully EoF as we break here :) 
      break; 
       
    _memAll[memPtr] = tmpReader; 
  } 
} 

uint32_t ds2423::readCounter(uint8_t counter) 
{ 
  uint32_t count; 
  uint8_t myTA1; 
uint8_t data[4]; 

  _wire->reset(); 
  _wire->select(_deviceAddress); 
  _wire->write(READCOUNTER, 0); 

  if (counter == 1) { 
    myTA1 = 0xC0; 
  } 
  else if (counter == 2) { 
    myTA1 = 0xE0; 
  } 

  _wire->write(myTA1, 0); 
  _wire->write(0x01, 0); 

  for (int i=0; i<32; i++) { 
    _wire->read(); //ignore data in that page 
  } 
   
for (int i=0; i<3; i++) { 
    data[i] = _wire->read();    // read in counter data 
  } 
  count = data[3]; 
  count = count << 8; 
  count |= data[2]; 
  count = count << 8; 
  count |= data[1]; 
  count = count << 8; 
  count |= data[0]; 
  
  return count; 
  
}  
